﻿using System;
using System.Collections.Generic;

namespace FaceDetection.Neural
{
  public abstract class Node
  {
    public double Input { get; set; }

    public double Output { get; private set; }

    private readonly List<Link> links;

    public Node()
    {
      links = new List<Link>();
    }

    public void AddLink(Node node, double weight)
    {
      links.Add(new Link(node, weight));
    }

    protected abstract double CalculateOutput();
    
    public void Activate()
    {
      Output = CalculateOutput();
      foreach (var link in links)
      {
        link.Node.Input += link.Weight * Output;
      }
    }
  }
}
